@echo off
color 8B

echo.
echo =========================================
echo            GROUND DEFORMATION
echo           Farming Simulator 25
echo.
echo.            Created By Static
echo.
echo     Need help? Contact me on Discord:
echo      https://discord.gg/Brsh35dBXK
echo =========================================
echo.

setlocal enabledelayedexpansion

if "%~1"=="" (
    echo Oops! It looks like you opened this script directly.
    echo Please drag and drop your map's .i3d file onto this script to modify it.
    echo This helps keep things simple and safe.
    echo.
    pause
    exit /b
)

set "inputFile=%~1"
set "extension=%~x1"

REM === Check if file extension is .i3d (case-insensitive) ===
if /I not "%extension%"==".i3d" (
    echo Error: The file you dropped is not an .i3d file.
    echo Please drag and drop a valid Farming Simulator .i3d map file.
    echo.
    pause
    exit /b
)

set "backupFile=%~dpn1_backup.i3d"

REM Prompt user for multiplier
:promptMultiplier
echo.
echo Select maxHeight multiplier (base is 0.2):
echo   1 = 1x (0.2) default
echo   2 = 2x (0.4)
echo   3 = 3x (0.6)
echo   4 = 4x (0.8)
echo   5 = 5x (1.0)
set /p choice="Enter 1-5: "

if "%choice%"=="1" set "newHeight=0.2"
if "%choice%"=="2" set "newHeight=0.4"
if "%choice%"=="3" set "newHeight=0.6"
if "%choice%"=="4" set "newHeight=0.8"
if "%choice%"=="5" set "newHeight=1.0"

if not defined newHeight (
    echo Invalid choice. Please try again.
    goto promptMultiplier
)

echo.
echo Backing up original...
copy "%inputFile%" "%backupFile%" >nul

echo Please wait, modifying "%inputFile%" to maxHeight=%newHeight%...

powershell -Command ^
  "$content = Get-Content -Raw '%inputFile%';" ^
  "$original = $content;" ^
  "$updated = [regex]::Replace($content, '(?i)(<DisplacementLayer\b[^>]*?\bmaxHeight\s*=\s*\"?)([\d\.]+)(\"?)', '${1}%newHeight%${3}');" ^
  "if ($updated -ne $original) { Set-Content -Encoding UTF8 '%inputFile%' $updated; 'Updated maxHeight to %newHeight%'; } else { 'Already modified, nothing changed.'; }"

pause
